(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
var keys = Object.keys;
var values = Object.values;
var ObjProto = Object.prototype;
var ArrayProto = Array.prototype;
var FuncProto = Function.prototype;
var toString = ObjProto.toString;
exports.default = {
    keys: keys,
    values: values,
    ObjProto: ObjProto,
    ArrayProto: ArrayProto,
    FuncProto: FuncProto,
    toString: toString,
    toNumber: function toNumber(value) {
        return toString.call(value) === '[object Number]' ? value : 0;
    }
};

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _prototype = __webpack_require__(0);

var _prototype2 = _interopRequireDefault(_prototype);

var _util = __webpack_require__(2);

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = Object.assign({}, _prototype2.default, _util2.default);

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _prototype = __webpack_require__(0);

var _prototype2 = _interopRequireDefault(_prototype);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    /**
     * 计算一组数据各占百分比
     * @param {Array|Object} [data=[]] 
     * @param {Number} [fixed=2] 
     * @returns 
     */
    scale: function scale() {
        var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        var fixed = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;

        var type = _prototype2.default.toString.call(data);
        if (type !== '[object Array]' && type !== '[object Object]') {
            return data;
        }
        var isArr = type === '[object Array]' ? 1 : 0;
        var tempData = [];
        var total = (isArr ? data : _prototype2.default.values(data)).reduce(function (sum, value) {
            var num = _prototype2.default.toNumber(value);
            tempData.push(num);
            return sum + num;
        }, 0);
        var scale = tempData.map(function (value) {
            return Number((value / total * 100).toFixed(fixed));
        });
        return isArr ? scale : function () {
            var obj = {};
            _prototype2.default.keys(data).forEach(function (key, index) {
                obj[key] = scale[index];
            });
            return obj;
        }();
    },

    /**
     * 深度拷贝
     * @param {Object} obj1 
     * @param {Object} obj2 
     * @returns 
     */
    mergeRecursive: function mergeRecursive(obj1, obj2) {
        for (var p in obj2) {
            try {
                if (obj2[p].constructor === Object) {
                    if (!obj1[p]) {
                        obj1[p] = {};
                    }
                    obj1[p] = this.mergeRecursive(obj1[p], obj2[p]);
                } else {
                    obj1[p] = obj2[p];
                }
            } catch (e) {}
        }

        return obj1;
    },

    /**
     * 按照value 排序 (value类型=Number)
     * 由于Object对象属性的输出顺序是无序的,所以返回值使用Map类型
     * http://w3help.org/zh-cn/causes/SJ9011
     * @param {Object} [data={}] 
     * @param {String} [order='asc'] |'desc'
     * @returns Map
     */
    sort: function sort() {
        var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var order = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'asc';

        if (_prototype2.default.toString.call(data) !== '[object Object]') {
            return data;
        }
        var map = new Map();
        var keys = _prototype2.default.keys(data).sort(function (a, b) {
            var aNum = _prototype2.default.toNumber(data[a]),
                bNum = _prototype2.default.toNumber(data[b]);
            return order === 'asc' ? aNum - bNum : bNum - aNum;
        }).forEach(function (key) {
            map.set(key, data[key]);
        });
        return map;
    },

    /**
     * 转换小写
     * @param {String} [data=''] 
     * @returns String
     */
    toLower: function toLower() {
        var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

        return data.replace(/[A-Z]/g, function (word) {
            return word.toLowerCase();
        });
    }
};

/***/ })
/******/ ]);
});